Listing 3 -- File-searching code

    // Return whether found or not - search forwards
    // If found, cLine is set to current line and file pointer
    // is at its start
    // If not found, file pointer remains untouched

    FUNCTION frwd_srch(cString)

    LOCAL lFound := .F., ;
          nSavePos := FTELL(nHandle), ;
          cSavecLine := cLine

        DO WHILE !lFound .AND. lGoNextLn()
          lFound := cString $ cLine
        ENDDO

        IF !lFound
          fseek(nHandle, nSavePos, FS_SET)
          cLine := cSavecLine
        ENDIF

    RETURN lFound


    // Return whether found or not - search backwards
    // If found, cLine is set to current line and file pointer
    // is at its start
    // If not found, file pointer remains untouched

    FUNCTION bkwd_srch(cString)

    LOCAL lFound := .F., ;
          nSavePos := FTELL(nHandle), ;
          cSavecLine := cLine

        DO WHILE !lFound .AND. lGoPrevLn()
          lFound := cString $ cLine
        ENDDO

        IF !lFound
          fseek(nHandle, nSavePos, FS_SET)
          cLine := cSavecLine
        ENDIF

    RETURN lFound


