PROCEDURE pop01
* first popup using DEFINE POPUP
PARAMETERS thisstate
* Make all variable that start with l_
* private to this procedure
PRIVATE ALL LIKE l_*
l_bkstates=.t.  
* Since the valid states are stored in the 
* bkstates database, make sure bkstates is open
IF !USED('bkstates') 
  USE bkstates IN SELECT(1) AGAIN
  * flag to show that bkstates was not open
  l_bkstates=.f.  
ENDIF bkstates not already open
* save old bkstates order
l_oldord=ORDER('bkstates')  
* if necessary, set order in bkstates
IF l_oldord#"ST_CODE"  
  SET ORDER TO st_code IN bkstates
ENDIF
* Save current record pointer in bkstates
l_bkstrec=RECNO('bkstates')
* Save current setting of SET NEAR
l_oldnear=SET('near')
SET NEAR ON
* see if the user gave us a valid value to begin with
IF !SEEK(thisstate,'bkstates')    && invalid state code
  * create the popup
  DEFINE POPUP pop01 FROM 3,8 to 9,40 ;
    TITLE "Pick a State" ;
    FOOTER "{Enter} to select" ;
    SHADOW SCROLL  ;
    PROMPT FIELD bkstates.st_code+;
    chr(179)+bkstates.st_name
  * now tell FoxPro what to do when the user 
  * chooses a state
  ON SELECTION POPUP pop01 DEACTIVATE POPUP pop01
  * Now enable the user to type characters and
  * get closer to the desired state
  l_oldconf=SET('CONFIRM')
  SET CONFIRM ON
  * Finally, start the popup at the current spot 
  * in the bkstates database
  ACTIVATE POPUP pop01 REST
  * Since the user must be positioned on a valid
  * state record, put the st_code value into our
  * memory variable
  thisstate = bkstates.st_code
  * clean up 
  RELEASE POPUP pop01
  IF l_oldconf#"ON"
    SET CONFIRM OFF
  ENDIF need to reset confirm
ENDIF entered an invalid value
* close bkstates if it wasn't open when we
* started this call to pop01
IF !l_bkstates
  USE IN bkstates
ELSE  && bkstates was open prior to pop01
  * reset the order in bkstates if necessary
  IF l_oldord#"ST_CODE"
    SET ORDER TO (l_oldord) IN BKSTATES
  ENDIF need to reset the order
  * go back to original record in bkstates
  GOTO l_bkstrec IN bkstates
ENDIF && bkstates was not open prior to pop01
* reset SET NEAR if necessary
IF l_oldnear#"ON"
  SET NEAR OFF
ENDIF
* Since the user either entered a valid value to 
* begin with, or subsequently was forced to choose
* a valid value, we can always return true
RETURN .T.
