***************************************************
* Tag_All
* Procedure for TAGging all fields in a DBF file.
* The DBF that will be indexed must be opened
* exclusively and currently selected.
***************************************************
Procedure Tag_All

* Define a window to show TAGging progress.
DEFINE WINDOW tag FROM 11,20 TO 14,60
ACTIVATE WINDOW tag

* Determine the number of fields in the current DBF.
Num_Fields=FCOUNT()

* Define a counter for the number of fields TAGged
Field_Loop=1

SET SAFETY OFF

* Do until all fields are indexed to a TAG name.
DO WHILE Field_Loop <= Num_Fields
   * Variable Fname holds the name of the current
   * field being indexed.
   Fname = RTRIM(FIELD(Field_Loop))
   * Show the field being indexed.
   CLEAR
   @ 0,15 SAY STR(Field_Loop,3) + ' of ' + ;
   STR(FCOUNT(),3)
   @ 1,15 SAY FIELD(Field_Loop)
   * If it isn't a memo field, then index it
   * directly, else index it on an expression
   * because memo fields can't be directly indexed.
   IF TYPE([&Fname]) != 'M'
      * Index the current field to a TAG with the
      * same name as the field
      INDEX ON &Fname tag &Fname
   ELSE              && If it is a memo field.
      * Empty (null) memo fields can cause an
      * error when the record pointer is at
      * EOF() because assigning a string of a
      * null field to a variable can cause a
      * string error. Fix by moving record
      * pointer to TOP.
      GO TOP
      * Index memo field on expression
      INDEX ON LEFT(&Fname,1) tag &Fname
   ENDIF
   * Increment field counter
   Field_Loop = Field_Loop + 1
ENDDO

RELEASE WINDOW tag

RETURN
**** End of Procedure Tag_All *********************

